!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(require("codemirror")):"function"==typeof define&&define.amd?define(["codemirror"],e):e((t=t||self).CodeMirror)}(this,function(t){"use strict";
/**
   * A specialized version of `_.map` for arrays without support for iteratee
   * shorthands.
   *
   * @private
   * @param {Array} [array] The array to iterate over.
   * @param {Function} iteratee The function invoked per iteration.
   * @returns {Array} Returns the new mapped array.
   */var e=function(t,e){for(var n=-1,r=null==t?0:t.length,o=Array(r);++n<r;)o[n]=e(t[n],n,t);return o};
/**
   * Removes all key-value entries from the list cache.
   *
   * @private
   * @name clear
   * @memberOf ListCache
   */var n=function(){this.__data__=[],this.size=0};
/**
   * Performs a
   * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
   * comparison between two values to determine if they are equivalent.
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to compare.
   * @param {*} other The other value to compare.
   * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
   * @example
   *
   * var object = { 'a': 1 };
   * var other = { 'a': 1 };
   *
   * _.eq(object, object);
   * // => true
   *
   * _.eq(object, other);
   * // => false
   *
   * _.eq('a', 'a');
   * // => true
   *
   * _.eq('a', Object('a'));
   * // => false
   *
   * _.eq(NaN, NaN);
   * // => true
   */var r=function(t,e){return t===e||t!=t&&e!=e};
/**
   * Gets the index at which the `key` is found in `array` of key-value pairs.
   *
   * @private
   * @param {Array} array The array to inspect.
   * @param {*} key The key to search for.
   * @returns {number} Returns the index of the matched value, else `-1`.
   */var o=function(t,e){for(var n=t.length;n--;)if(r(t[n][0],e))return n;return-1},i=Array.prototype.splice;
/** Used for built-in method references. */var a=
/**
   * Removes `key` and its value from the list cache.
   *
   * @private
   * @name delete
   * @memberOf ListCache
   * @param {string} key The key of the value to remove.
   * @returns {boolean} Returns `true` if the entry was removed, else `false`.
   */
function(t){var e=this.__data__,n=o(e,t);return!(n<0||(n==e.length-1?e.pop():i.call(e,n,1),--this.size,0))};
/**
   * Gets the list cache value for `key`.
   *
   * @private
   * @name get
   * @memberOf ListCache
   * @param {string} key The key of the value to get.
   * @returns {*} Returns the entry value.
   */var c=function(t){var e=this.__data__,n=o(e,t);return n<0?void 0:e[n][1]};
/**
   * Checks if a list cache value for `key` exists.
   *
   * @private
   * @name has
   * @memberOf ListCache
   * @param {string} key The key of the entry to check.
   * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
   */var u=function(t){return o(this.__data__,t)>-1};
/**
   * Sets the list cache `key` to `value`.
   *
   * @private
   * @name set
   * @memberOf ListCache
   * @param {string} key The key of the value to set.
   * @param {*} value The value to set.
   * @returns {Object} Returns the list cache instance.
   */var s=function(t,e){var n=this.__data__,r=o(n,t);return r<0?(++this.size,n.push([t,e])):n[r][1]=e,this};
/**
   * Creates an list cache object.
   *
   * @private
   * @constructor
   * @param {Array} [entries] The key-value pairs to cache.
   */function l(t){var e=-1,n=null==t?0:t.length;for(this.clear();++e<n;){var r=t[e];this.set(r[0],r[1])}}// Add methods to `ListCache`.
l.prototype.clear=n,l.prototype.delete=a,l.prototype.get=c,l.prototype.has=u,l.prototype.set=s;var f=l;
/**
   * Removes all key-value entries from the stack.
   *
   * @private
   * @name clear
   * @memberOf Stack
   */var v=function(){this.__data__=new f,this.size=0};
/**
   * Removes `key` and its value from the stack.
   *
   * @private
   * @name delete
   * @memberOf Stack
   * @param {string} key The key of the value to remove.
   * @returns {boolean} Returns `true` if the entry was removed, else `false`.
   */var h=function(t){var e=this.__data__,n=e.delete(t);return this.size=e.size,n};
/**
   * Gets the stack value for `key`.
   *
   * @private
   * @name get
   * @memberOf Stack
   * @param {string} key The key of the value to get.
   * @returns {*} Returns the entry value.
   */var p=function(t){return this.__data__.get(t)};
/**
   * Checks if a stack value for `key` exists.
   *
   * @private
   * @name has
   * @memberOf Stack
   * @param {string} key The key of the entry to check.
   * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
   */var d=function(t){return this.__data__.has(t)},g="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function y(t,e){return t(e={exports:{}},e.exports),e.exports
/** Detect free variable `global` from Node.js. */}var b="object"==typeof g&&g&&g.Object===Object&&g,_="object"==typeof self&&self&&self.Object===Object&&self,m=b||_||Function("return this")(),j=m.Symbol,k=Object.prototype,w=k.hasOwnProperty,x=k.toString,O=j?j.toStringTag:void 0;var A=
/**
   * A specialized version of `baseGetTag` which ignores `Symbol.toStringTag` values.
   *
   * @private
   * @param {*} value The value to query.
   * @returns {string} Returns the raw `toStringTag`.
   */
function(t){var e=w.call(t,O),n=t[O];try{t[O]=void 0;var r=!0}catch(t){}var o=x.call(t);return r&&(e?t[O]=n:delete t[O]),o},M=Object.prototype.toString;
/** Used for built-in method references. */var S=
/**
   * Converts `value` to a string using `Object.prototype.toString`.
   *
   * @private
   * @param {*} value The value to convert.
   * @returns {string} Returns the converted string.
   */
function(t){return M.call(t)},P="[object Null]",E="[object Undefined]",T=j?j.toStringTag:void 0;
/** `Object#toString` result references. */var C=
/**
   * The base implementation of `getTag` without fallbacks for buggy environments.
   *
   * @private
   * @param {*} value The value to query.
   * @returns {string} Returns the `toStringTag`.
   */
function(t){return null==t?void 0===t?E:P:T&&T in Object(t)?A(t):S(t)};
/**
   * Checks if `value` is the
   * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
   * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is an object, else `false`.
   * @example
   *
   * _.isObject({});
   * // => true
   *
   * _.isObject([1, 2, 3]);
   * // => true
   *
   * _.isObject(_.noop);
   * // => true
   *
   * _.isObject(null);
   * // => false
   */var z=function(t){var e=typeof t;return null!=t&&("object"==e||"function"==e)},F="[object AsyncFunction]",L="[object Function]",I="[object GeneratorFunction]",R="[object Proxy]";
/** `Object#toString` result references. */var $,B=
/**
   * Checks if `value` is classified as a `Function` object.
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a function, else `false`.
   * @example
   *
   * _.isFunction(_);
   * // => true
   *
   * _.isFunction(/abc/);
   * // => false
   */
function(t){if(!z(t))return!1;// The use of `Object#toString` avoids issues with the `typeof` operator
// in Safari 9 which returns 'object' for typed arrays and other constructors.
var e=C(t);return e==L||e==I||e==F||e==R},W=m["__core-js_shared__"],U=($=/[^.]+$/.exec(W&&W.keys&&W.keys.IE_PROTO||""))?"Symbol(src)_1."+$:"";
/** Used to detect overreaching core-js shims. */var D=
/**
   * Checks if `func` has its source masked.
   *
   * @private
   * @param {Function} func The function to check.
   * @returns {boolean} Returns `true` if `func` is masked, else `false`.
   */
function(t){return!!U&&U in t},N=Function.prototype.toString;
/** Used for built-in method references. */var V=
/**
   * Converts `func` to its source code.
   *
   * @private
   * @param {Function} func The function to convert.
   * @returns {string} Returns the source code.
   */
function(t){if(null!=t){try{return N.call(t)}catch(t){}try{return t+""}catch(t){}}return""},q=/^\[object .+?Constructor\]$/,G=Function.prototype,H=Object.prototype,J=G.toString,K=H.hasOwnProperty,Q=RegExp("^"+J.call(K).replace(/[\\^$.*+?()[\]{}|]/g,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$");
/**
   * Used to match `RegExp`
   * [syntax characters](http://ecma-international.org/ecma-262/7.0/#sec-patterns).
   */var X=
/**
   * The base implementation of `_.isNative` without bad shim checks.
   *
   * @private
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a native function,
   *  else `false`.
   */
function(t){return!(!z(t)||D(t))&&(B(t)?Q:q).test(V(t))};
/**
   * Gets the value at `key` of `object`.
   *
   * @private
   * @param {Object} [object] The object to query.
   * @param {string} key The key of the property to get.
   * @returns {*} Returns the property value.
   */var Y=function(t,e){return null==t?void 0:t[e]};
/**
   * Gets the native function at `key` of `object`.
   *
   * @private
   * @param {Object} object The object to query.
   * @param {string} key The key of the method to get.
   * @returns {*} Returns the function if it's native, else `undefined`.
   */var Z=function(t,e){var n=Y(t,e);return X(n)?n:void 0},tt=Z(m,"Map"),et=Z(Object,"create");
/* Built-in method references that are verified to be native. */var nt=
/**
   * Removes all key-value entries from the hash.
   *
   * @private
   * @name clear
   * @memberOf Hash
   */
function(){this.__data__=et?et(null):{},this.size=0};
/**
   * Removes `key` and its value from the hash.
   *
   * @private
   * @name delete
   * @memberOf Hash
   * @param {Object} hash The hash to modify.
   * @param {string} key The key of the value to remove.
   * @returns {boolean} Returns `true` if the entry was removed, else `false`.
   */var rt=function(t){var e=this.has(t)&&delete this.__data__[t];return this.size-=e?1:0,e},ot="__lodash_hash_undefined__",it=Object.prototype.hasOwnProperty;
/** Used to stand-in for `undefined` hash values. */var at=
/**
   * Gets the hash value for `key`.
   *
   * @private
   * @name get
   * @memberOf Hash
   * @param {string} key The key of the value to get.
   * @returns {*} Returns the entry value.
   */
function(t){var e=this.__data__;if(et){var n=e[t];return n===ot?void 0:n}return it.call(e,t)?e[t]:void 0},ct=Object.prototype.hasOwnProperty;
/** Used for built-in method references. */var ut=
/**
   * Checks if a hash value for `key` exists.
   *
   * @private
   * @name has
   * @memberOf Hash
   * @param {string} key The key of the entry to check.
   * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
   */
function(t){var e=this.__data__;return et?void 0!==e[t]:ct.call(e,t)},st="__lodash_hash_undefined__";
/** Used to stand-in for `undefined` hash values. */var lt=
/**
   * Sets the hash `key` to `value`.
   *
   * @private
   * @name set
   * @memberOf Hash
   * @param {string} key The key of the value to set.
   * @param {*} value The value to set.
   * @returns {Object} Returns the hash instance.
   */
function(t,e){var n=this.__data__;return this.size+=this.has(t)?0:1,n[t]=et&&void 0===e?st:e,this};
/**
   * Creates a hash object.
   *
   * @private
   * @constructor
   * @param {Array} [entries] The key-value pairs to cache.
   */function ft(t){var e=-1,n=null==t?0:t.length;for(this.clear();++e<n;){var r=t[e];this.set(r[0],r[1])}}// Add methods to `Hash`.
ft.prototype.clear=nt,ft.prototype.delete=rt,ft.prototype.get=at,ft.prototype.has=ut,ft.prototype.set=lt;var vt=ft;
/**
   * Removes all key-value entries from the map.
   *
   * @private
   * @name clear
   * @memberOf MapCache
   */var ht=function(){this.size=0,this.__data__={hash:new vt,map:new(tt||f),string:new vt}};
/**
   * Checks if `value` is suitable for use as unique object key.
   *
   * @private
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is suitable, else `false`.
   */var pt=function(t){var e=typeof t;return"string"==e||"number"==e||"symbol"==e||"boolean"==e?"__proto__"!==t:null===t};
/**
   * Gets the data for `map`.
   *
   * @private
   * @param {Object} map The map to query.
   * @param {string} key The reference key.
   * @returns {*} Returns the map data.
   */var dt=function(t,e){var n=t.__data__;return pt(e)?n["string"==typeof e?"string":"hash"]:n.map};
/**
   * Removes `key` and its value from the map.
   *
   * @private
   * @name delete
   * @memberOf MapCache
   * @param {string} key The key of the value to remove.
   * @returns {boolean} Returns `true` if the entry was removed, else `false`.
   */var gt=function(t){var e=dt(this,t).delete(t);return this.size-=e?1:0,e};
/**
   * Gets the map value for `key`.
   *
   * @private
   * @name get
   * @memberOf MapCache
   * @param {string} key The key of the value to get.
   * @returns {*} Returns the entry value.
   */var yt=function(t){return dt(this,t).get(t)};
/**
   * Checks if a map value for `key` exists.
   *
   * @private
   * @name has
   * @memberOf MapCache
   * @param {string} key The key of the entry to check.
   * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
   */var bt=function(t){return dt(this,t).has(t)};
/**
   * Sets the map `key` to `value`.
   *
   * @private
   * @name set
   * @memberOf MapCache
   * @param {string} key The key of the value to set.
   * @param {*} value The value to set.
   * @returns {Object} Returns the map cache instance.
   */var _t=function(t,e){var n=dt(this,t),r=n.size;return n.set(t,e),this.size+=n.size==r?0:1,this};
/**
   * Creates a map cache object to store key-value pairs.
   *
   * @private
   * @constructor
   * @param {Array} [entries] The key-value pairs to cache.
   */function mt(t){var e=-1,n=null==t?0:t.length;for(this.clear();++e<n;){var r=t[e];this.set(r[0],r[1])}}// Add methods to `MapCache`.
mt.prototype.clear=ht,mt.prototype.delete=gt,mt.prototype.get=yt,mt.prototype.has=bt,mt.prototype.set=_t;var jt=mt,kt=200;
/** Used as the size to enable large array optimizations. */var wt=
/**
   * Sets the stack `key` to `value`.
   *
   * @private
   * @name set
   * @memberOf Stack
   * @param {string} key The key of the value to set.
   * @param {*} value The value to set.
   * @returns {Object} Returns the stack cache instance.
   */
function(t,e){var n=this.__data__;if(n instanceof f){var r=n.__data__;if(!tt||r.length<kt-1)return r.push([t,e]),this.size=++n.size,this;n=this.__data__=new jt(r)}return n.set(t,e),this.size=n.size,this};
/**
   * Creates a stack cache object to store key-value pairs.
   *
   * @private
   * @constructor
   * @param {Array} [entries] The key-value pairs to cache.
   */function xt(t){var e=this.__data__=new f(t);this.size=e.size}// Add methods to `Stack`.
xt.prototype.clear=v,xt.prototype.delete=h,xt.prototype.get=p,xt.prototype.has=d,xt.prototype.set=wt;var Ot=xt,At="__lodash_hash_undefined__";
/** Used to stand-in for `undefined` hash values. */var Mt=
/**
   * Adds `value` to the array cache.
   *
   * @private
   * @name add
   * @memberOf SetCache
   * @alias push
   * @param {*} value The value to cache.
   * @returns {Object} Returns the cache instance.
   */
function(t){return this.__data__.set(t,At),this};
/**
   * Checks if `value` is in the array cache.
   *
   * @private
   * @name has
   * @memberOf SetCache
   * @param {*} value The value to search for.
   * @returns {number} Returns `true` if `value` is found, else `false`.
   */var St=function(t){return this.__data__.has(t)};
/**
   *
   * Creates an array cache object to store unique values.
   *
   * @private
   * @constructor
   * @param {Array} [values] The values to cache.
   */function Pt(t){var e=-1,n=null==t?0:t.length;for(this.__data__=new jt;++e<n;)this.add(t[e])}// Add methods to `SetCache`.
Pt.prototype.add=Pt.prototype.push=Mt,Pt.prototype.has=St;var Et=Pt;
/**
   * A specialized version of `_.some` for arrays without support for iteratee
   * shorthands.
   *
   * @private
   * @param {Array} [array] The array to iterate over.
   * @param {Function} predicate The function invoked per iteration.
   * @returns {boolean} Returns `true` if any element passes the predicate check,
   *  else `false`.
   */var Tt=function(t,e){for(var n=-1,r=null==t?0:t.length;++n<r;)if(e(t[n],n,t))return!0;return!1};
/**
   * Checks if a `cache` value for `key` exists.
   *
   * @private
   * @param {Object} cache The cache to query.
   * @param {string} key The key of the entry to check.
   * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
   */var Ct=function(t,e){return t.has(e)},zt=1,Ft=2;
/** Used to compose bitmasks for value comparisons. */var Lt=
/**
   * A specialized version of `baseIsEqualDeep` for arrays with support for
   * partial deep comparisons.
   *
   * @private
   * @param {Array} array The array to compare.
   * @param {Array} other The other array to compare.
   * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
   * @param {Function} customizer The function to customize comparisons.
   * @param {Function} equalFunc The function to determine equivalents of values.
   * @param {Object} stack Tracks traversed `array` and `other` objects.
   * @returns {boolean} Returns `true` if the arrays are equivalent, else `false`.
   */
function(t,e,n,r,o,i){var a=n&zt,c=t.length,u=e.length;if(c!=u&&!(a&&u>c))return!1;// Assume cyclic values are equal.
var s=i.get(t);if(s&&i.get(e))return s==e;var l=-1,f=!0,v=n&Ft?new Et:void 0;// Ignore non-index properties.
for(i.set(t,e),i.set(e,t);++l<c;){var h=t[l],p=e[l];if(r)var d=a?r(p,h,l,e,t,i):r(h,p,l,t,e,i);if(void 0!==d){if(d)continue;f=!1;break}// Recursively compare arrays (susceptible to call stack limits).
if(v){if(!Tt(e,function(t,e){if(!Ct(v,e)&&(h===t||o(h,t,n,r,i)))return v.push(e)})){f=!1;break}}else if(h!==p&&!o(h,p,n,r,i)){f=!1;break}}return i.delete(t),i.delete(e),f},It=m.Uint8Array;
/** Built-in value references. */var Rt=
/**
   * Converts `map` to its key-value pairs.
   *
   * @private
   * @param {Object} map The map to convert.
   * @returns {Array} Returns the key-value pairs.
   */
function(t){var e=-1,n=Array(t.size);return t.forEach(function(t,r){n[++e]=[r,t]}),n};
/**
   * Converts `set` to an array of its values.
   *
   * @private
   * @param {Object} set The set to convert.
   * @returns {Array} Returns the values.
   */var $t=function(t){var e=-1,n=Array(t.size);return t.forEach(function(t){n[++e]=t}),n},Bt=1,Wt=2,Ut="[object Boolean]",Dt="[object Date]",Nt="[object Error]",Vt="[object Map]",qt="[object Number]",Gt="[object RegExp]",Ht="[object Set]",Jt="[object String]",Kt="[object Symbol]",Qt="[object ArrayBuffer]",Xt="[object DataView]",Yt=j?j.prototype:void 0,Zt=Yt?Yt.valueOf:void 0;
/** Used to compose bitmasks for value comparisons. */var te=
/**
   * A specialized version of `baseIsEqualDeep` for comparing objects of
   * the same `toStringTag`.
   *
   * **Note:** This function only supports comparing values with tags of
   * `Boolean`, `Date`, `Error`, `Number`, `RegExp`, or `String`.
   *
   * @private
   * @param {Object} object The object to compare.
   * @param {Object} other The other object to compare.
   * @param {string} tag The `toStringTag` of the objects to compare.
   * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
   * @param {Function} customizer The function to customize comparisons.
   * @param {Function} equalFunc The function to determine equivalents of values.
   * @param {Object} stack Tracks traversed `object` and `other` objects.
   * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
   */
function(t,e,n,o,i,a,c){switch(n){case Xt:if(t.byteLength!=e.byteLength||t.byteOffset!=e.byteOffset)return!1;t=t.buffer,e=e.buffer;case Qt:return!(t.byteLength!=e.byteLength||!a(new It(t),new It(e)));case Ut:case Dt:case qt:
// Coerce booleans to `1` or `0` and dates to milliseconds.
// Invalid dates are coerced to `NaN`.
return r(+t,+e);case Nt:return t.name==e.name&&t.message==e.message;case Gt:case Jt:
// Coerce regexes to strings and treat strings, primitives and objects,
// as equal. See http://www.ecma-international.org/ecma-262/7.0/#sec-regexp.prototype.tostring
// for more details.
return t==e+"";case Vt:var u=Rt;case Ht:var s=o&Bt;if(u||(u=$t),t.size!=e.size&&!s)return!1;// Assume cyclic values are equal.
var l=c.get(t);if(l)return l==e;o|=Wt,// Recursively compare objects (susceptible to call stack limits).
c.set(t,e);var f=Lt(u(t),u(e),o,i,a,c);return c.delete(t),f;case Kt:if(Zt)return Zt.call(t)==Zt.call(e)}return!1};
/**
   * Appends the elements of `values` to `array`.
   *
   * @private
   * @param {Array} array The array to modify.
   * @param {Array} values The values to append.
   * @returns {Array} Returns `array`.
   */var ee=function(t,e){for(var n=-1,r=e.length,o=t.length;++n<r;)t[o+n]=e[n];return t},ne=Array.isArray;
/**
   * Checks if `value` is classified as an `Array` object.
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is an array, else `false`.
   * @example
   *
   * _.isArray([1, 2, 3]);
   * // => true
   *
   * _.isArray(document.body.children);
   * // => false
   *
   * _.isArray('abc');
   * // => false
   *
   * _.isArray(_.noop);
   * // => false
   */var re=
/**
   * The base implementation of `getAllKeys` and `getAllKeysIn` which uses
   * `keysFunc` and `symbolsFunc` to get the enumerable property names and
   * symbols of `object`.
   *
   * @private
   * @param {Object} object The object to query.
   * @param {Function} keysFunc The function to get the keys of `object`.
   * @param {Function} symbolsFunc The function to get the symbols of `object`.
   * @returns {Array} Returns the array of property names and symbols.
   */
function(t,e,n){var r=e(t);return ne(t)?r:ee(r,n(t))};
/**
   * A specialized version of `_.filter` for arrays without support for
   * iteratee shorthands.
   *
   * @private
   * @param {Array} [array] The array to iterate over.
   * @param {Function} predicate The function invoked per iteration.
   * @returns {Array} Returns the new filtered array.
   */var oe=function(t,e){for(var n=-1,r=null==t?0:t.length,o=0,i=[];++n<r;){var a=t[n];e(a,n,t)&&(i[o++]=a)}return i};
/**
   * This method returns a new empty array.
   *
   * @static
   * @memberOf _
   * @since 4.13.0
   * @category Util
   * @returns {Array} Returns the new empty array.
   * @example
   *
   * var arrays = _.times(2, _.stubArray);
   *
   * console.log(arrays);
   * // => [[], []]
   *
   * console.log(arrays[0] === arrays[1]);
   * // => false
   */var ie=function(){return[]},ae=Object.prototype.propertyIsEnumerable,ce=Object.getOwnPropertySymbols,ue=ce?function(t){return null==t?[]:(t=Object(t),oe(ce(t),function(e){return ae.call(t,e)}))}:ie;
/** Used for built-in method references. */var se=
/**
   * The base implementation of `_.times` without support for iteratee shorthands
   * or max array length checks.
   *
   * @private
   * @param {number} n The number of times to invoke `iteratee`.
   * @param {Function} iteratee The function invoked per iteration.
   * @returns {Array} Returns the array of results.
   */
function(t,e){for(var n=-1,r=Array(t);++n<t;)r[n]=e(n);return r};
/**
   * Checks if `value` is object-like. A value is object-like if it's not `null`
   * and has a `typeof` result of "object".
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
   * @example
   *
   * _.isObjectLike({});
   * // => true
   *
   * _.isObjectLike([1, 2, 3]);
   * // => true
   *
   * _.isObjectLike(_.noop);
   * // => false
   *
   * _.isObjectLike(null);
   * // => false
   */var le=function(t){return null!=t&&"object"==typeof t},fe="[object Arguments]";
/** `Object#toString` result references. */var ve=
/**
   * The base implementation of `_.isArguments`.
   *
   * @private
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is an `arguments` object,
   */
function(t){return le(t)&&C(t)==fe},he=Object.prototype,pe=he.hasOwnProperty,de=he.propertyIsEnumerable,ge=ve(function(){return arguments}())?ve:function(t){return le(t)&&pe.call(t,"callee")&&!de.call(t,"callee")};
/** Used for built-in method references. */var ye=
/**
   * This method returns `false`.
   *
   * @static
   * @memberOf _
   * @since 4.13.0
   * @category Util
   * @returns {boolean} Returns `false`.
   * @example
   *
   * _.times(2, _.stubFalse);
   * // => [false, false]
   */
function(){return!1},be=y(function(t,e){
/** Detect free variable `exports`. */
var n=e&&!e.nodeType&&e,r=n&&t&&!t.nodeType&&t,o=r&&r.exports===n?m.Buffer:void 0,i=(o?o.isBuffer:void 0)||ye;
/** Detect free variable `module`. */t.exports=i}),_e=9007199254740991,me=/^(?:0|[1-9]\d*)$/;var je=
/**
   * Checks if `value` is a valid array-like index.
   *
   * @private
   * @param {*} value The value to check.
   * @param {number} [length=MAX_SAFE_INTEGER] The upper bounds of a valid index.
   * @returns {boolean} Returns `true` if `value` is a valid index, else `false`.
   */
function(t,e){var n=typeof t;return!!(e=null==e?_e:e)&&("number"==n||"symbol"!=n&&me.test(t))&&t>-1&&t%1==0&&t<e},ke=9007199254740991;
/** Used as references for various `Number` constants. */var we=
/**
   * Checks if `value` is a valid array-like length.
   *
   * **Note:** This method is loosely based on
   * [`ToLength`](http://ecma-international.org/ecma-262/7.0/#sec-tolength).
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a valid length, else `false`.
   * @example
   *
   * _.isLength(3);
   * // => true
   *
   * _.isLength(Number.MIN_VALUE);
   * // => false
   *
   * _.isLength(Infinity);
   * // => false
   *
   * _.isLength('3');
   * // => false
   */
function(t){return"number"==typeof t&&t>-1&&t%1==0&&t<=ke},xe={};
/** `Object#toString` result references. */xe["[object Float32Array]"]=xe["[object Float64Array]"]=xe["[object Int8Array]"]=xe["[object Int16Array]"]=xe["[object Int32Array]"]=xe["[object Uint8Array]"]=xe["[object Uint8ClampedArray]"]=xe["[object Uint16Array]"]=xe["[object Uint32Array]"]=!0,xe["[object Arguments]"]=xe["[object Array]"]=xe["[object ArrayBuffer]"]=xe["[object Boolean]"]=xe["[object DataView]"]=xe["[object Date]"]=xe["[object Error]"]=xe["[object Function]"]=xe["[object Map]"]=xe["[object Number]"]=xe["[object Object]"]=xe["[object RegExp]"]=xe["[object Set]"]=xe["[object String]"]=xe["[object WeakMap]"]=!1;var Oe=
/**
   * The base implementation of `_.isTypedArray` without Node.js optimizations.
   *
   * @private
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
   */
function(t){return le(t)&&we(t.length)&&!!xe[C(t)]};
/**
   * The base implementation of `_.unary` without support for storing metadata.
   *
   * @private
   * @param {Function} func The function to cap arguments for.
   * @returns {Function} Returns the new capped function.
   */var Ae=function(t){return function(e){return t(e)}},Me=y(function(t,e){
/** Detect free variable `exports`. */
var n=e&&!e.nodeType&&e,r=n&&t&&!t.nodeType&&t,o=r&&r.exports===n&&b.process,i=function(){try{
// Use `util.types` for Node.js 10+.
var t=r&&r.require&&r.require("util").types;return t||o&&o.binding&&o.binding("util");// Legacy `process.binding('util')` for Node.js < 10.
}catch(t){}}();
/** Detect free variable `module`. */t.exports=i}),Se=Me&&Me.isTypedArray,Pe=Se?Ae(Se):Oe,Ee=Object.prototype.hasOwnProperty;var Te=
/**
   * Creates an array of the enumerable property names of the array-like `value`.
   *
   * @private
   * @param {*} value The value to query.
   * @param {boolean} inherited Specify returning inherited property names.
   * @returns {Array} Returns the array of property names.
   */
function(t,e){var n=ne(t),r=!n&&ge(t),o=!n&&!r&&be(t),i=!n&&!r&&!o&&Pe(t),a=n||r||o||i,c=a?se(t.length,String):[],u=c.length;for(var s in t)!e&&!Ee.call(t,s)||a&&(// Safari 9 has enumerable `arguments.length` in strict mode.
"length"==s||// Node.js 0.10 has enumerable non-index properties on buffers.
o&&("offset"==s||"parent"==s)||// PhantomJS 2 has enumerable non-index properties on typed arrays.
i&&("buffer"==s||"byteLength"==s||"byteOffset"==s)||// Skip index properties.
je(s,u))||c.push(s);return c},Ce=Object.prototype;
/** Used for built-in method references. */var ze=
/**
   * Checks if `value` is likely a prototype object.
   *
   * @private
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a prototype, else `false`.
   */
function(t){var e=t&&t.constructor;return t===("function"==typeof e&&e.prototype||Ce)};
/**
   * Creates a unary function that invokes `func` with its argument transformed.
   *
   * @private
   * @param {Function} func The function to wrap.
   * @param {Function} transform The argument transform.
   * @returns {Function} Returns the new function.
   */var Fe=function(t,e){return function(n){return t(e(n))}},Le=Fe(Object.keys,Object),Ie=Object.prototype.hasOwnProperty;
/* Built-in method references for those with the same name as other `lodash` methods. */var Re=
/**
   * The base implementation of `_.keys` which doesn't treat sparse arrays as dense.
   *
   * @private
   * @param {Object} object The object to query.
   * @returns {Array} Returns the array of property names.
   */
function(t){if(!ze(t))return Le(t);var e=[];for(var n in Object(t))Ie.call(t,n)&&"constructor"!=n&&e.push(n);return e};
/**
   * Checks if `value` is array-like. A value is considered array-like if it's
   * not a function and has a `value.length` that's an integer greater than or
   * equal to `0` and less than or equal to `Number.MAX_SAFE_INTEGER`.
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is array-like, else `false`.
   * @example
   *
   * _.isArrayLike([1, 2, 3]);
   * // => true
   *
   * _.isArrayLike(document.body.children);
   * // => true
   *
   * _.isArrayLike('abc');
   * // => true
   *
   * _.isArrayLike(_.noop);
   * // => false
   */var $e=function(t){return null!=t&&we(t.length)&&!B(t)};
/**
   * Creates an array of the own enumerable property names of `object`.
   *
   * **Note:** Non-object values are coerced to objects. See the
   * [ES spec](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
   * for more details.
   *
   * @static
   * @since 0.1.0
   * @memberOf _
   * @category Object
   * @param {Object} object The object to query.
   * @returns {Array} Returns the array of property names.
   * @example
   *
   * function Foo() {
   *   this.a = 1;
   *   this.b = 2;
   * }
   *
   * Foo.prototype.c = 3;
   *
   * _.keys(new Foo);
   * // => ['a', 'b'] (iteration order is not guaranteed)
   *
   * _.keys('hi');
   * // => ['0', '1']
   */var Be=function(t){return $e(t)?Te(t):Re(t)};
/**
   * Creates an array of own enumerable property names and symbols of `object`.
   *
   * @private
   * @param {Object} object The object to query.
   * @returns {Array} Returns the array of property names and symbols.
   */var We=function(t){return re(t,Be,ue)},Ue=1,De=Object.prototype.hasOwnProperty;
/** Used to compose bitmasks for value comparisons. */var Ne=
/**
   * A specialized version of `baseIsEqualDeep` for objects with support for
   * partial deep comparisons.
   *
   * @private
   * @param {Object} object The object to compare.
   * @param {Object} other The other object to compare.
   * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
   * @param {Function} customizer The function to customize comparisons.
   * @param {Function} equalFunc The function to determine equivalents of values.
   * @param {Object} stack Tracks traversed `object` and `other` objects.
   * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
   */
function(t,e,n,r,o,i){var a=n&Ue,c=We(t),u=c.length;if(u!=We(e).length&&!a)return!1;for(var s=u;s--;){var l=c[s];if(!(a?l in e:De.call(e,l)))return!1}// Assume cyclic values are equal.
var f=i.get(t);if(f&&i.get(e))return f==e;var v=!0;i.set(t,e),i.set(e,t);for(var h=a;++s<u;){var p=t[l=c[s]],d=e[l];if(r)var g=a?r(d,p,l,e,t,i):r(p,d,l,t,e,i);// Recursively compare objects (susceptible to call stack limits).
if(!(void 0===g?p===d||o(p,d,n,r,i):g)){v=!1;break}h||(h="constructor"==l)}if(v&&!h){var y=t.constructor,b=e.constructor;// Non `Object` object instances with different constructors are not equal.
y!=b&&"constructor"in t&&"constructor"in e&&!("function"==typeof y&&y instanceof y&&"function"==typeof b&&b instanceof b)&&(v=!1)}return i.delete(t),i.delete(e),v},Ve=Z(m,"DataView"),qe=Z(m,"Promise"),Ge=Z(m,"Set"),He=Z(m,"WeakMap"),Je=V(Ve),Ke=V(tt),Qe=V(qe),Xe=V(Ge),Ye=V(He),Ze=C;
/* Built-in method references that are verified to be native. */ // Fallback for data views, maps, sets, and weak maps in IE 11 and promises in Node.js < 6.
(Ve&&"[object DataView]"!=Ze(new Ve(new ArrayBuffer(1)))||tt&&"[object Map]"!=Ze(new tt)||qe&&"[object Promise]"!=Ze(qe.resolve())||Ge&&"[object Set]"!=Ze(new Ge)||He&&"[object WeakMap]"!=Ze(new He))&&(Ze=function(t){var e=C(t),n="[object Object]"==e?t.constructor:void 0,r=n?V(n):"";if(r)switch(r){case Je:return"[object DataView]";case Ke:return"[object Map]";case Qe:return"[object Promise]";case Xe:return"[object Set]";case Ye:return"[object WeakMap]"}return e});var tn=Ze,en=1,nn="[object Arguments]",rn="[object Array]",on="[object Object]",an=Object.prototype.hasOwnProperty;
/** Used to compose bitmasks for value comparisons. */var cn=
/**
   * A specialized version of `baseIsEqual` for arrays and objects which performs
   * deep comparisons and tracks traversed objects enabling objects with circular
   * references to be compared.
   *
   * @private
   * @param {Object} object The object to compare.
   * @param {Object} other The other object to compare.
   * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
   * @param {Function} customizer The function to customize comparisons.
   * @param {Function} equalFunc The function to determine equivalents of values.
   * @param {Object} [stack] Tracks traversed `object` and `other` objects.
   * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
   */
function(t,e,n,r,o,i){var a=ne(t),c=ne(e),u=a?rn:tn(t),s=c?rn:tn(e),l=(u=u==nn?on:u)==on,f=(s=s==nn?on:s)==on,v=u==s;if(v&&be(t)){if(!be(e))return!1;a=!0,l=!1}if(v&&!l)return i||(i=new Ot),a||Pe(t)?Lt(t,e,n,r,o,i):te(t,e,u,n,r,o,i);if(!(n&en)){var h=l&&an.call(t,"__wrapped__"),p=f&&an.call(e,"__wrapped__");if(h||p){var d=h?t.value():t,g=p?e.value():e;return i||(i=new Ot),o(d,g,n,r,i)}}return!!v&&(i||(i=new Ot),Ne(t,e,n,r,o,i))};
/**
   * The base implementation of `_.isEqual` which supports partial comparisons
   * and tracks traversed objects.
   *
   * @private
   * @param {*} value The value to compare.
   * @param {*} other The other value to compare.
   * @param {boolean} bitmask The bitmask flags.
   *  1 - Unordered comparison
   *  2 - Partial comparison
   * @param {Function} [customizer] The function to customize comparisons.
   * @param {Object} [stack] Tracks traversed `value` and `other` objects.
   * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
   */var un=function t(e,n,r,o,i){return e===n||(null==e||null==n||!le(e)&&!le(n)?e!=e&&n!=n:cn(e,n,r,o,t,i))},sn=1,ln=2;
/** Used to compose bitmasks for value comparisons. */var fn=
/**
   * The base implementation of `_.isMatch` without support for iteratee shorthands.
   *
   * @private
   * @param {Object} object The object to inspect.
   * @param {Object} source The object of property values to match.
   * @param {Array} matchData The property names, values, and compare flags to match.
   * @param {Function} [customizer] The function to customize comparisons.
   * @returns {boolean} Returns `true` if `object` is a match, else `false`.
   */
function(t,e,n,r){var o=n.length,i=o,a=!r;if(null==t)return!i;for(t=Object(t);o--;){var c=n[o];if(a&&c[2]?c[1]!==t[c[0]]:!(c[0]in t))return!1}for(;++o<i;){var u=(c=n[o])[0],s=t[u],l=c[1];if(a&&c[2]){if(void 0===s&&!(u in t))return!1}else{var f=new Ot;if(r)var v=r(s,l,u,t,e,f);if(!(void 0===v?un(l,s,sn|ln,r,f):v))return!1}}return!0};
/**
   * Checks if `value` is suitable for strict equality comparisons, i.e. `===`.
   *
   * @private
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` if suitable for strict
   *  equality comparisons, else `false`.
   */var vn=function(t){return t==t&&!z(t)};
/**
   * Gets the property names, values, and compare flags of `object`.
   *
   * @private
   * @param {Object} object The object to query.
   * @returns {Array} Returns the match data of `object`.
   */var hn=function(t){for(var e=Be(t),n=e.length;n--;){var r=e[n],o=t[r];e[n]=[r,o,vn(o)]}return e};
/**
   * A specialized version of `matchesProperty` for source values suitable
   * for strict equality comparisons, i.e. `===`.
   *
   * @private
   * @param {string} key The key of the property to get.
   * @param {*} srcValue The value to match.
   * @returns {Function} Returns the new spec function.
   */var pn=function(t,e){return function(n){return null!=n&&n[t]===e&&(void 0!==e||t in Object(n))}};
/**
   * The base implementation of `_.matches` which doesn't clone `source`.
   *
   * @private
   * @param {Object} source The object of property values to match.
   * @returns {Function} Returns the new spec function.
   */var dn=function(t){var e=hn(t);return 1==e.length&&e[0][2]?pn(e[0][0],e[0][1]):function(n){return n===t||fn(n,t,e)}},gn="[object Symbol]";
/** `Object#toString` result references. */var yn=
/**
   * Checks if `value` is classified as a `Symbol` primitive or object.
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
   * @example
   *
   * _.isSymbol(Symbol.iterator);
   * // => true
   *
   * _.isSymbol('abc');
   * // => false
   */
function(t){return"symbol"==typeof t||le(t)&&C(t)==gn},bn=/\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,_n=/^\w*$/;
/** Used to match property names within property paths. */var mn=
/**
   * Checks if `value` is a property name and not a property path.
   *
   * @private
   * @param {*} value The value to check.
   * @param {Object} [object] The object to query keys on.
   * @returns {boolean} Returns `true` if `value` is a property name, else `false`.
   */
function(t,e){if(ne(t))return!1;var n=typeof t;return!("number"!=n&&"symbol"!=n&&"boolean"!=n&&null!=t&&!yn(t))||_n.test(t)||!bn.test(t)||null!=e&&t in Object(e)},jn="Expected a function";
/** Error message constants. */
/**
   * Creates a function that memoizes the result of `func`. If `resolver` is
   * provided, it determines the cache key for storing the result based on the
   * arguments provided to the memoized function. By default, the first argument
   * provided to the memoized function is used as the map cache key. The `func`
   * is invoked with the `this` binding of the memoized function.
   *
   * **Note:** The cache is exposed as the `cache` property on the memoized
   * function. Its creation may be customized by replacing the `_.memoize.Cache`
   * constructor with one whose instances implement the
   * [`Map`](http://ecma-international.org/ecma-262/7.0/#sec-properties-of-the-map-prototype-object)
   * method interface of `clear`, `delete`, `get`, `has`, and `set`.
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Function
   * @param {Function} func The function to have its output memoized.
   * @param {Function} [resolver] The function to resolve the cache key.
   * @returns {Function} Returns the new memoized function.
   * @example
   *
   * var object = { 'a': 1, 'b': 2 };
   * var other = { 'c': 3, 'd': 4 };
   *
   * var values = _.memoize(_.values);
   * values(object);
   * // => [1, 2]
   *
   * values(other);
   * // => [3, 4]
   *
   * object.a = 2;
   * values(object);
   * // => [1, 2]
   *
   * // Modify the result cache.
   * values.cache.set(object, ['a', 'b']);
   * values(object);
   * // => ['a', 'b']
   *
   * // Replace `_.memoize.Cache`.
   * _.memoize.Cache = WeakMap;
   */
function kn(t,e){if("function"!=typeof t||null!=e&&"function"!=typeof e)throw new TypeError(jn);var n=function(){var r=arguments,o=e?e.apply(this,r):r[0],i=n.cache;if(i.has(o))return i.get(o);var a=t.apply(this,r);return n.cache=i.set(o,a)||i,a};return n.cache=new(kn.Cache||jt),n}// Expose `MapCache`.
kn.Cache=jt;var wn=kn,xn=500;
/** Used as the maximum memoize cache size. */var On=/[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g,An=/\\(\\)?/g,Mn=
/**
   * A specialized version of `_.memoize` which clears the memoized function's
   * cache when it exceeds `MAX_MEMOIZE_SIZE`.
   *
   * @private
   * @param {Function} func The function to have its output memoized.
   * @returns {Function} Returns the new memoized function.
   */
function(t){var e=wn(t,function(t){return n.size===xn&&n.clear(),t}),n=e.cache;return e}(function(t){var e=[];return 46
/* . */===t.charCodeAt(0)&&e.push(""),t.replace(On,function(t,n,r,o){e.push(r?o.replace(An,"$1"):n||t)}),e}),Sn=1/0,Pn=j?j.prototype:void 0,En=Pn?Pn.toString:void 0;
/** Used to match property names within property paths. */var Tn=
/**
   * The base implementation of `_.toString` which doesn't convert nullish
   * values to empty strings.
   *
   * @private
   * @param {*} value The value to process.
   * @returns {string} Returns the string.
   */
function t(n){
// Exit early for strings to avoid a performance hit in some environments.
if("string"==typeof n)return n;if(ne(n))
// Recursively convert values (susceptible to call stack limits).
return e(n,t)+"";if(yn(n))return En?En.call(n):"";var r=n+"";return"0"==r&&1/n==-Sn?"-0":r};
/**
   * Converts `value` to a string. An empty string is returned for `null`
   * and `undefined` values. The sign of `-0` is preserved.
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to convert.
   * @returns {string} Returns the converted string.
   * @example
   *
   * _.toString(null);
   * // => ''
   *
   * _.toString(-0);
   * // => '-0'
   *
   * _.toString([1, 2, 3]);
   * // => '1,2,3'
   */var Cn=function(t){return null==t?"":Tn(t)};
/**
   * Casts `value` to a path array if it's not one.
   *
   * @private
   * @param {*} value The value to inspect.
   * @param {Object} [object] The object to query keys on.
   * @returns {Array} Returns the cast property path array.
   */var zn=function(t,e){return ne(t)?t:mn(t,e)?[t]:Mn(Cn(t))},Fn=1/0;
/** Used as references for various `Number` constants. */var Ln=
/**
   * Converts `value` to a string key if it's not a string or symbol.
   *
   * @private
   * @param {*} value The value to inspect.
   * @returns {string|symbol} Returns the key.
   */
function(t){if("string"==typeof t||yn(t))return t;var e=t+"";return"0"==e&&1/t==-Fn?"-0":e};
/**
   * The base implementation of `_.get` without support for default values.
   *
   * @private
   * @param {Object} object The object to query.
   * @param {Array|string} path The path of the property to get.
   * @returns {*} Returns the resolved value.
   */var In=function(t,e){for(var n=0,r=(e=zn(e,t)).length;null!=t&&n<r;)t=t[Ln(e[n++])];return n&&n==r?t:void 0};
/**
   * Gets the value at `path` of `object`. If the resolved value is
   * `undefined`, the `defaultValue` is returned in its place.
   *
   * @static
   * @memberOf _
   * @since 3.7.0
   * @category Object
   * @param {Object} object The object to query.
   * @param {Array|string} path The path of the property to get.
   * @param {*} [defaultValue] The value returned for `undefined` resolved values.
   * @returns {*} Returns the resolved value.
   * @example
   *
   * var object = { 'a': [{ 'b': { 'c': 3 } }] };
   *
   * _.get(object, 'a[0].b.c');
   * // => 3
   *
   * _.get(object, ['a', '0', 'b', 'c']);
   * // => 3
   *
   * _.get(object, 'a.b.c', 'default');
   * // => 'default'
   */var Rn=function(t,e,n){var r=null==t?void 0:In(t,e);return void 0===r?n:r};
/**
   * The base implementation of `_.hasIn` without support for deep paths.
   *
   * @private
   * @param {Object} [object] The object to query.
   * @param {Array|string} key The key to check.
   * @returns {boolean} Returns `true` if `key` exists, else `false`.
   */var $n=function(t,e){return null!=t&&e in Object(t)};
/**
   * Checks if `path` exists on `object`.
   *
   * @private
   * @param {Object} object The object to query.
   * @param {Array|string} path The path to check.
   * @param {Function} hasFunc The function to check properties.
   * @returns {boolean} Returns `true` if `path` exists, else `false`.
   */var Bn=function(t,e,n){for(var r=-1,o=(e=zn(e,t)).length,i=!1;++r<o;){var a=Ln(e[r]);if(!(i=null!=t&&n(t,a)))break;t=t[a]}return i||++r!=o?i:!!(o=null==t?0:t.length)&&we(o)&&je(a,o)&&(ne(t)||ge(t))};
/**
   * Checks if `path` is a direct or inherited property of `object`.
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Object
   * @param {Object} object The object to query.
   * @param {Array|string} path The path to check.
   * @returns {boolean} Returns `true` if `path` exists, else `false`.
   * @example
   *
   * var object = _.create({ 'a': _.create({ 'b': 2 }) });
   *
   * _.hasIn(object, 'a');
   * // => true
   *
   * _.hasIn(object, 'a.b');
   * // => true
   *
   * _.hasIn(object, ['a', 'b']);
   * // => true
   *
   * _.hasIn(object, 'b');
   * // => false
   */var Wn=function(t,e){return null!=t&&Bn(t,e,$n)},Un=1,Dn=2;
/** Used to compose bitmasks for value comparisons. */var Nn=
/**
   * The base implementation of `_.matchesProperty` which doesn't clone `srcValue`.
   *
   * @private
   * @param {string} path The path of the property to get.
   * @param {*} srcValue The value to match.
   * @returns {Function} Returns the new spec function.
   */
function(t,e){return mn(t)&&vn(e)?pn(Ln(t),e):function(n){var r=Rn(n,t);return void 0===r&&r===e?Wn(n,t):un(e,r,Un|Dn)}};
/**
   * This method returns the first argument it receives.
   *
   * @static
   * @since 0.1.0
   * @memberOf _
   * @category Util
   * @param {*} value Any value.
   * @returns {*} Returns `value`.
   * @example
   *
   * var object = { 'a': 1 };
   *
   * console.log(_.identity(object) === object);
   * // => true
   */var Vn=function(t){return t};
/**
   * The base implementation of `_.property` without support for deep paths.
   *
   * @private
   * @param {string} key The key of the property to get.
   * @returns {Function} Returns the new accessor function.
   */var qn=function(t){return function(e){return null==e?void 0:e[t]}};
/**
   * A specialized version of `baseProperty` which supports deep paths.
   *
   * @private
   * @param {Array|string} path The path of the property to get.
   * @returns {Function} Returns the new accessor function.
   */var Gn=function(t){return function(e){return In(e,t)}};
/**
   * Creates a function that returns the value at `path` of a given object.
   *
   * @static
   * @memberOf _
   * @since 2.4.0
   * @category Util
   * @param {Array|string} path The path of the property to get.
   * @returns {Function} Returns the new accessor function.
   * @example
   *
   * var objects = [
   *   { 'a': { 'b': 2 } },
   *   { 'a': { 'b': 1 } }
   * ];
   *
   * _.map(objects, _.property('a.b'));
   * // => [2, 1]
   *
   * _.map(_.sortBy(objects, _.property(['a', 'b'])), 'a.b');
   * // => [1, 2]
   */var Hn=function(t){return mn(t)?qn(Ln(t)):Gn(t)};
/**
   * The base implementation of `_.iteratee`.
   *
   * @private
   * @param {*} [value=_.identity] The value to convert to an iteratee.
   * @returns {Function} Returns the iteratee.
   */var Jn=function(t){
// Don't store the `typeof` result in a variable to avoid a JIT bug in Safari 9.
// See https://bugs.webkit.org/show_bug.cgi?id=156034 for more details.
return"function"==typeof t?t:null==t?Vn:"object"==typeof t?ne(t)?Nn(t[0],t[1]):dn(t):Hn(t)};
/**
   * Creates a base function for methods like `_.forIn` and `_.forOwn`.
   *
   * @private
   * @param {boolean} [fromRight] Specify iterating from right to left.
   * @returns {Function} Returns the new base function.
   */var Kn=function(t){return function(e,n,r){for(var o=-1,i=Object(e),a=r(e),c=a.length;c--;){var u=a[t?c:++o];if(!1===n(i[u],u,i))break}return e}}();
/**
   * The base implementation of `baseForOwn` which iterates over `object`
   * properties returned by `keysFunc` and invokes `iteratee` for each property.
   * Iteratee functions may exit iteration early by explicitly returning `false`.
   *
   * @private
   * @param {Object} object The object to iterate over.
   * @param {Function} iteratee The function invoked per iteration.
   * @param {Function} keysFunc The function to get the keys of `object`.
   * @returns {Object} Returns `object`.
   */var Qn=
/**
   * Creates a `baseEach` or `baseEachRight` function.
   *
   * @private
   * @param {Function} eachFunc The function to iterate over a collection.
   * @param {boolean} [fromRight] Specify iterating from right to left.
   * @returns {Function} Returns the new base function.
   */
function(t,e){return function(n,r){if(null==n)return n;if(!$e(n))return t(n,r);for(var o=n.length,i=e?o:-1,a=Object(n);(e?i--:++i<o)&&!1!==r(a[i],i,a););return n}}(
/**
   * The base implementation of `_.forOwn` without support for iteratee shorthands.
   *
   * @private
   * @param {Object} object The object to iterate over.
   * @param {Function} iteratee The function invoked per iteration.
   * @returns {Object} Returns `object`.
   */
function(t,e){return t&&Kn(t,e,Be)});
/**
   * The base implementation of `_.forEach` without support for iteratee shorthands.
   *
   * @private
   * @param {Array|Object} collection The collection to iterate over.
   * @param {Function} iteratee The function invoked per iteration.
   * @returns {Array|Object} Returns `collection`.
   */var Xn=
/**
   * The base implementation of `_.map` without support for iteratee shorthands.
   *
   * @private
   * @param {Array|Object} collection The collection to iterate over.
   * @param {Function} iteratee The function invoked per iteration.
   * @returns {Array} Returns the new mapped array.
   */
function(t,e){var n=-1,r=$e(t)?Array(t.length):[];return Qn(t,function(t,o,i){r[++n]=e(t,o,i)}),r};
/**
   * Creates an array of values by running each element in `collection` thru
   * `iteratee`. The iteratee is invoked with three arguments:
   * (value, index|key, collection).
   *
   * Many lodash methods are guarded to work as iteratees for methods like
   * `_.every`, `_.filter`, `_.map`, `_.mapValues`, `_.reject`, and `_.some`.
   *
   * The guarded methods are:
   * `ary`, `chunk`, `curry`, `curryRight`, `drop`, `dropRight`, `every`,
   * `fill`, `invert`, `parseInt`, `random`, `range`, `rangeRight`, `repeat`,
   * `sampleSize`, `slice`, `some`, `sortBy`, `split`, `take`, `takeRight`,
   * `template`, `trim`, `trimEnd`, `trimStart`, and `words`
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Collection
   * @param {Array|Object} collection The collection to iterate over.
   * @param {Function} [iteratee=_.identity] The function invoked per iteration.
   * @returns {Array} Returns the new mapped array.
   * @example
   *
   * function square(n) {
   *   return n * n;
   * }
   *
   * _.map([4, 8], square);
   * // => [16, 64]
   *
   * _.map({ 'a': 4, 'b': 8 }, square);
   * // => [16, 64] (iteration order is not guaranteed)
   *
   * var users = [
   *   { 'user': 'barney' },
   *   { 'user': 'fred' }
   * ];
   *
   * // The `_.property` iteratee shorthand.
   * _.map(users, 'user');
   * // => ['barney', 'fred']
   */var Yn=function(t,n){return(ne(t)?e:Xn)(t,Jn(n))};
/**
   * A specialized version of `_.forEach` for arrays without support for
   * iteratee shorthands.
   *
   * @private
   * @param {Array} [array] The array to iterate over.
   * @param {Function} iteratee The function invoked per iteration.
   * @returns {Array} Returns `array`.
   */var Zn=function(t,e){for(var n=-1,r=null==t?0:t.length;++n<r&&!1!==e(t[n],n,t););return t},tr=function(){try{var t=Z(Object,"defineProperty");return t({},"",{}),t}catch(t){}}();var er=
/**
   * The base implementation of `assignValue` and `assignMergeValue` without
   * value checks.
   *
   * @private
   * @param {Object} object The object to modify.
   * @param {string} key The key of the property to assign.
   * @param {*} value The value to assign.
   */
function(t,e,n){"__proto__"==e&&tr?tr(t,e,{configurable:!0,enumerable:!0,value:n,writable:!0}):t[e]=n},nr=Object.prototype.hasOwnProperty;
/** Used for built-in method references. */var rr=
/**
   * Assigns `value` to `key` of `object` if the existing value is not equivalent
   * using [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
   * for equality comparisons.
   *
   * @private
   * @param {Object} object The object to modify.
   * @param {string} key The key of the property to assign.
   * @param {*} value The value to assign.
   */
function(t,e,n){var o=t[e];nr.call(t,e)&&r(o,n)&&(void 0!==n||e in t)||er(t,e,n)};
/**
   * Copies properties of `source` to `object`.
   *
   * @private
   * @param {Object} source The object to copy properties from.
   * @param {Array} props The property identifiers to copy.
   * @param {Object} [object={}] The object to copy properties to.
   * @param {Function} [customizer] The function to customize copied values.
   * @returns {Object} Returns `object`.
   */var or=function(t,e,n,r){var o=!n;n||(n={});for(var i=-1,a=e.length;++i<a;){var c=e[i],u=r?r(n[c],t[c],c,n,t):void 0;void 0===u&&(u=t[c]),o?er(n,c,u):rr(n,c,u)}return n};
/**
   * The base implementation of `_.assign` without support for multiple sources
   * or `customizer` functions.
   *
   * @private
   * @param {Object} object The destination object.
   * @param {Object} source The source object.
   * @returns {Object} Returns `object`.
   */var ir=function(t,e){return t&&or(e,Be(e),t)};
/**
   * This function is like
   * [`Object.keys`](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
   * except that it includes inherited enumerable properties.
   *
   * @private
   * @param {Object} object The object to query.
   * @returns {Array} Returns the array of property names.
   */var ar=function(t){var e=[];if(null!=t)for(var n in Object(t))e.push(n);return e},cr=Object.prototype.hasOwnProperty;
/** Used for built-in method references. */var ur=
/**
   * The base implementation of `_.keysIn` which doesn't treat sparse arrays as dense.
   *
   * @private
   * @param {Object} object The object to query.
   * @returns {Array} Returns the array of property names.
   */
function(t){if(!z(t))return ar(t);var e=ze(t),n=[];for(var r in t)("constructor"!=r||!e&&cr.call(t,r))&&n.push(r);return n};
/**
   * Creates an array of the own and inherited enumerable property names of `object`.
   *
   * **Note:** Non-object values are coerced to objects.
   *
   * @static
   * @memberOf _
   * @since 3.0.0
   * @category Object
   * @param {Object} object The object to query.
   * @returns {Array} Returns the array of property names.
   * @example
   *
   * function Foo() {
   *   this.a = 1;
   *   this.b = 2;
   * }
   *
   * Foo.prototype.c = 3;
   *
   * _.keysIn(new Foo);
   * // => ['a', 'b', 'c'] (iteration order is not guaranteed)
   */var sr=function(t){return $e(t)?Te(t,!0):ur(t)};
/**
   * The base implementation of `_.assignIn` without support for multiple sources
   * or `customizer` functions.
   *
   * @private
   * @param {Object} object The destination object.
   * @param {Object} source The source object.
   * @returns {Object} Returns `object`.
   */var lr=function(t,e){return t&&or(e,sr(e),t)},fr=y(function(t,e){
/** Detect free variable `exports`. */
var n=e&&!e.nodeType&&e,r=n&&t&&!t.nodeType&&t,o=r&&r.exports===n?m.Buffer:void 0,i=o?o.allocUnsafe:void 0;
/** Detect free variable `module`. */t.exports=
/**
   * Creates a clone of  `buffer`.
   *
   * @private
   * @param {Buffer} buffer The buffer to clone.
   * @param {boolean} [isDeep] Specify a deep clone.
   * @returns {Buffer} Returns the cloned buffer.
   */
function(t,e){if(e)return t.slice();var n=t.length,r=i?i(n):new t.constructor(n);return t.copy(r),r}});var vr=
/**
   * Copies the values of `source` to `array`.
   *
   * @private
   * @param {Array} source The array to copy values from.
   * @param {Array} [array=[]] The array to copy values to.
   * @returns {Array} Returns `array`.
   */
function(t,e){var n=-1,r=t.length;for(e||(e=Array(r));++n<r;)e[n]=t[n];return e};
/**
   * Copies own symbols of `source` to `object`.
   *
   * @private
   * @param {Object} source The object to copy symbols from.
   * @param {Object} [object={}] The object to copy symbols to.
   * @returns {Object} Returns `object`.
   */var hr=function(t,e){return or(t,ue(t),e)},pr=Fe(Object.getPrototypeOf,Object),dr=Object.getOwnPropertySymbols?function(t){for(var e=[];t;)ee(e,ue(t)),t=pr(t);return e}:ie;
/** Built-in value references. */var gr=
/**
   * Copies own and inherited symbols of `source` to `object`.
   *
   * @private
   * @param {Object} source The object to copy symbols from.
   * @param {Object} [object={}] The object to copy symbols to.
   * @returns {Object} Returns `object`.
   */
function(t,e){return or(t,dr(t),e)};
/**
   * Creates an array of own and inherited enumerable property names and
   * symbols of `object`.
   *
   * @private
   * @param {Object} object The object to query.
   * @returns {Array} Returns the array of property names and symbols.
   */var yr=function(t){return re(t,sr,dr)},br=Object.prototype.hasOwnProperty;
/** Used for built-in method references. */var _r=
/**
   * Initializes an array clone.
   *
   * @private
   * @param {Array} array The array to clone.
   * @returns {Array} Returns the initialized clone.
   */
function(t){var e=t.length,n=new t.constructor(e);// Add properties assigned by `RegExp#exec`.
return e&&"string"==typeof t[0]&&br.call(t,"index")&&(n.index=t.index,n.input=t.input),n};
/**
   * Creates a clone of `arrayBuffer`.
   *
   * @private
   * @param {ArrayBuffer} arrayBuffer The array buffer to clone.
   * @returns {ArrayBuffer} Returns the cloned array buffer.
   */var mr=function(t){var e=new t.constructor(t.byteLength);return new It(e).set(new It(t)),e};
/**
   * Creates a clone of `dataView`.
   *
   * @private
   * @param {Object} dataView The data view to clone.
   * @param {boolean} [isDeep] Specify a deep clone.
   * @returns {Object} Returns the cloned data view.
   */var jr=function(t,e){var n=e?mr(t.buffer):t.buffer;return new t.constructor(n,t.byteOffset,t.byteLength)},kr=/\w*$/;
/** Used to match `RegExp` flags from their coerced string values. */var wr=
/**
   * Creates a clone of `regexp`.
   *
   * @private
   * @param {Object} regexp The regexp to clone.
   * @returns {Object} Returns the cloned regexp.
   */
function(t){var e=new t.constructor(t.source,kr.exec(t));return e.lastIndex=t.lastIndex,e},xr=j?j.prototype:void 0,Or=xr?xr.valueOf:void 0;
/** Used to convert symbols to primitives and strings. */var Ar=
/**
   * Creates a clone of the `symbol` object.
   *
   * @private
   * @param {Object} symbol The symbol object to clone.
   * @returns {Object} Returns the cloned symbol object.
   */
function(t){return Or?Object(Or.call(t)):{}};
/**
   * Creates a clone of `typedArray`.
   *
   * @private
   * @param {Object} typedArray The typed array to clone.
   * @param {boolean} [isDeep] Specify a deep clone.
   * @returns {Object} Returns the cloned typed array.
   */var Mr=function(t,e){var n=e?mr(t.buffer):t.buffer;return new t.constructor(n,t.byteOffset,t.length)},Sr="[object Boolean]",Pr="[object Date]",Er="[object Map]",Tr="[object Number]",Cr="[object RegExp]",zr="[object Set]",Fr="[object String]",Lr="[object Symbol]",Ir="[object ArrayBuffer]",Rr="[object DataView]",$r="[object Float32Array]",Br="[object Float64Array]",Wr="[object Int8Array]",Ur="[object Int16Array]",Dr="[object Int32Array]",Nr="[object Uint8Array]",Vr="[object Uint8ClampedArray]",qr="[object Uint16Array]",Gr="[object Uint32Array]";
/** `Object#toString` result references. */var Hr=
/**
   * Initializes an object clone based on its `toStringTag`.
   *
   * **Note:** This function only supports cloning values with tags of
   * `Boolean`, `Date`, `Error`, `Map`, `Number`, `RegExp`, `Set`, or `String`.
   *
   * @private
   * @param {Object} object The object to clone.
   * @param {string} tag The `toStringTag` of the object to clone.
   * @param {boolean} [isDeep] Specify a deep clone.
   * @returns {Object} Returns the initialized clone.
   */
function(t,e,n){var r=t.constructor;switch(e){case Ir:return mr(t);case Sr:case Pr:return new r(+t);case Rr:return jr(t,n);case $r:case Br:case Wr:case Ur:case Dr:case Nr:case Vr:case qr:case Gr:return Mr(t,n);case Er:return new r;case Tr:case Fr:return new r(t);case Cr:return wr(t);case zr:return new r;case Lr:return Ar(t)}},Jr=Object.create,Kr=function(){function t(){}return function(e){if(!z(e))return{};if(Jr)return Jr(e);t.prototype=e;var n=new t;return t.prototype=void 0,n}}();
/** Built-in value references. */var Qr=
/**
   * Initializes an object clone.
   *
   * @private
   * @param {Object} object The object to clone.
   * @returns {Object} Returns the initialized clone.
   */
function(t){return"function"!=typeof t.constructor||ze(t)?{}:Kr(pr(t))},Xr="[object Map]";
/** `Object#toString` result references. */var Yr=
/**
   * The base implementation of `_.isMap` without Node.js optimizations.
   *
   * @private
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a map, else `false`.
   */
function(t){return le(t)&&tn(t)==Xr},Zr=Me&&Me.isMap,to=Zr?Ae(Zr):Yr,eo="[object Set]";
/* Node.js helper references. */var no=
/**
   * The base implementation of `_.isSet` without Node.js optimizations.
   *
   * @private
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a set, else `false`.
   */
function(t){return le(t)&&tn(t)==eo},ro=Me&&Me.isSet,oo=ro?Ae(ro):no,io=1,ao=2,co=4,uo="[object Arguments]",so="[object Function]",lo="[object GeneratorFunction]",fo="[object Object]",vo={};
/* Node.js helper references. */vo[uo]=vo["[object Array]"]=vo["[object ArrayBuffer]"]=vo["[object DataView]"]=vo["[object Boolean]"]=vo["[object Date]"]=vo["[object Float32Array]"]=vo["[object Float64Array]"]=vo["[object Int8Array]"]=vo["[object Int16Array]"]=vo["[object Int32Array]"]=vo["[object Map]"]=vo["[object Number]"]=vo[fo]=vo["[object RegExp]"]=vo["[object Set]"]=vo["[object String]"]=vo["[object Symbol]"]=vo["[object Uint8Array]"]=vo["[object Uint8ClampedArray]"]=vo["[object Uint16Array]"]=vo["[object Uint32Array]"]=!0,vo["[object Error]"]=vo[so]=vo["[object WeakMap]"]=!1;var ho=
/**
   * The base implementation of `_.clone` and `_.cloneDeep` which tracks
   * traversed objects.
   *
   * @private
   * @param {*} value The value to clone.
   * @param {boolean} bitmask The bitmask flags.
   *  1 - Deep clone
   *  2 - Flatten inherited properties
   *  4 - Clone symbols
   * @param {Function} [customizer] The function to customize cloning.
   * @param {string} [key] The key of `value`.
   * @param {Object} [object] The parent object of `value`.
   * @param {Object} [stack] Tracks traversed objects and their clone counterparts.
   * @returns {*} Returns the cloned value.
   */
function t(e,n,r,o,i,a){var c,u=n&io,s=n&ao,l=n&co;if(r&&(c=i?r(e,o,i,a):r(e)),void 0!==c)return c;if(!z(e))return e;var f=ne(e);if(f){if(c=_r(e),!u)return vr(e,c)}else{var v=tn(e),h=v==so||v==lo;if(be(e))return fr(e,u);if(v==fo||v==uo||h&&!i){if(c=s||h?{}:Qr(e),!u)return s?gr(e,lr(c,e)):hr(e,ir(c,e))}else{if(!vo[v])return i?e:{};c=Hr(e,v,u)}}// Check for circular references and return its corresponding clone.
a||(a=new Ot);var p=a.get(e);if(p)return p;a.set(e,c),oo(e)?e.forEach(function(o){c.add(t(o,n,r,o,e,a))}):to(e)&&e.forEach(function(o,i){c.set(i,t(o,n,r,i,e,a))});var d=l?s?yr:We:s?keysIn:Be,g=f?void 0:d(e);return Zn(g||e,function(o,i){g&&(o=e[i=o]),// Recursively populate clone (susceptible to call stack limits).
rr(c,i,t(o,n,r,i,e,a))}),c},po=1,go=4;
/** Used to compose bitmasks for cloning. */var yo=
/**
   * This method is like `_.clone` except that it recursively clones `value`.
   *
   * @static
   * @memberOf _
   * @since 1.0.0
   * @category Lang
   * @param {*} value The value to recursively clone.
   * @returns {*} Returns the deep cloned value.
   * @see _.clone
   * @example
   *
   * var objects = [{ 'a': 1 }, { 'b': 2 }];
   *
   * var deep = _.cloneDeep(objects);
   * console.log(deep[0] === objects[0]);
   * // => false
   */
function(t){return ho(t,po|go)};
/**
   * Casts `value` to `identity` if it's not a function.
   *
   * @private
   * @param {*} value The value to inspect.
   * @returns {Function} Returns cast function.
   */var bo=function(t){return"function"==typeof t?t:Vn};
/**
   * Iterates over elements of `collection` and invokes `iteratee` for each element.
   * The iteratee is invoked with three arguments: (value, index|key, collection).
   * Iteratee functions may exit iteration early by explicitly returning `false`.
   *
   * **Note:** As with other "Collections" methods, objects with a "length"
   * property are iterated like arrays. To avoid this behavior use `_.forIn`
   * or `_.forOwn` for object iteration.
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @alias each
   * @category Collection
   * @param {Array|Object} collection The collection to iterate over.
   * @param {Function} [iteratee=_.identity] The function invoked per iteration.
   * @returns {Array|Object} Returns `collection`.
   * @see _.forEachRight
   * @example
   *
   * _.forEach([1, 2], function(value) {
   *   console.log(value);
   * });
   * // => Logs `1` then `2`.
   *
   * _.forEach({ 'a': 1, 'b': 2 }, function(value, key) {
   *   console.log(key);
   * });
   * // => Logs 'a' then 'b' (iteration order is not guaranteed).
   */var _o=function(t,e){return(ne(t)?Zn:Qn)(t,bo(e))};var mo=
/**
   * A faster alternative to `Function#apply`, this function invokes `func`
   * with the `this` binding of `thisArg` and the arguments of `args`.
   *
   * @private
   * @param {Function} func The function to invoke.
   * @param {*} thisArg The `this` binding of `func`.
   * @param {Array} args The arguments to invoke `func` with.
   * @returns {*} Returns the result of `func`.
   */
function(t,e,n){switch(n.length){case 0:return t.call(e);case 1:return t.call(e,n[0]);case 2:return t.call(e,n[0],n[1]);case 3:return t.call(e,n[0],n[1],n[2])}return t.apply(e,n)},jo=Math.max;
/* Built-in method references for those with the same name as other `lodash` methods. */var ko=
/**
   * A specialized version of `baseRest` which transforms the rest array.
   *
   * @private
   * @param {Function} func The function to apply a rest parameter to.
   * @param {number} [start=func.length-1] The start position of the rest parameter.
   * @param {Function} transform The rest array transform.
   * @returns {Function} Returns the new function.
   */
function(t,e,n){return e=jo(void 0===e?t.length-1:e,0),function(){for(var r=arguments,o=-1,i=jo(r.length-e,0),a=Array(i);++o<i;)a[o]=r[e+o];o=-1;for(var c=Array(e+1);++o<e;)c[o]=r[o];return c[e]=n(a),mo(t,this,c)}};
/**
   * Creates a function that returns `value`.
   *
   * @static
   * @memberOf _
   * @since 2.4.0
   * @category Util
   * @param {*} value The value to return from the new function.
   * @returns {Function} Returns the new constant function.
   * @example
   *
   * var objects = _.times(2, _.constant({ 'a': 1 }));
   *
   * console.log(objects);
   * // => [{ 'a': 1 }, { 'a': 1 }]
   *
   * console.log(objects[0] === objects[1]);
   * // => true
   */var wo=function(t){return function(){return t}},xo=tr?function(t,e){return tr(t,"toString",{configurable:!0,enumerable:!1,value:wo(e),writable:!0})}:Vn,Oo=800,Ao=16,Mo=Date.now;
/**
   * The base implementation of `setToString` without support for hot loop shorting.
   *
   * @private
   * @param {Function} func The function to modify.
   * @param {Function} string The `toString` result.
   * @returns {Function} Returns `func`.
   */var So=
/**
   * Creates a function that'll short out and invoke `identity` instead
   * of `func` when it's called `HOT_COUNT` or more times in `HOT_SPAN`
   * milliseconds.
   *
   * @private
   * @param {Function} func The function to restrict.
   * @returns {Function} Returns the new shortable function.
   */
function(t){var e=0,n=0;return function(){var r=Mo(),o=Ao-(r-n);if(n=r,o>0){if(++e>=Oo)return arguments[0]}else e=0;return t.apply(void 0,arguments)}}(xo);
/**
   * Sets the `toString` method of `func` to return `string`.
   *
   * @private
   * @param {Function} func The function to modify.
   * @param {Function} string The `toString` result.
   * @returns {Function} Returns `func`.
   */var Po=
/**
   * The base implementation of `_.rest` which doesn't validate or coerce arguments.
   *
   * @private
   * @param {Function} func The function to apply a rest parameter to.
   * @param {number} [start=func.length-1] The start position of the rest parameter.
   * @returns {Function} Returns the new function.
   */
function(t,e){return So(ko(t,e,Vn),t+"")};
/**
   * Checks if the given arguments are from an iteratee call.
   *
   * @private
   * @param {*} value The potential iteratee value argument.
   * @param {*} index The potential iteratee index or key argument.
   * @param {*} object The potential iteratee object argument.
   * @returns {boolean} Returns `true` if the arguments are from an iteratee call,
   *  else `false`.
   */var Eo=function(t,e,n){if(!z(n))return!1;var o=typeof e;return!!("number"==o?$e(n)&&je(e,n.length):"string"==o&&e in n)&&r(n[e],t)},To=Object.prototype,Co=To.hasOwnProperty,zo=Po(function(t,e){t=Object(t);var n=-1,o=e.length,i=o>2?e[2]:void 0;for(i&&Eo(e[0],e[1],i)&&(o=1);++n<o;)for(var a=e[n],c=sr(a),u=-1,s=c.length;++u<s;){var l=c[u],f=t[l];(void 0===f||r(f,To[l])&&!Co.call(t,l))&&(t[l]=a[l])}return t}),Fo=4294967294,Lo=Math.floor,Io=Math.min;
/** Used for built-in method references. */var Ro=
/**
   * The base implementation of `_.sortedIndexBy` and `_.sortedLastIndexBy`
   * which invokes `iteratee` for `value` and each element of `array` to compute
   * their sort ranking. The iteratee is invoked with one argument; (value).
   *
   * @private
   * @param {Array} array The sorted array to inspect.
   * @param {*} value The value to evaluate.
   * @param {Function} iteratee The iteratee invoked per element.
   * @param {boolean} [retHighest] Specify returning the highest qualified index.
   * @returns {number} Returns the index at which `value` should be inserted
   *  into `array`.
   */
function(t,e,n,r){e=n(e);for(var o=0,i=null==t?0:t.length,a=e!=e,c=null===e,u=yn(e),s=void 0===e;o<i;){var l=Lo((o+i)/2),f=n(t[l]),v=void 0!==f,h=null===f,p=f==f,d=yn(f);if(a)var g=r||p;else g=s?p&&(r||v):c?p&&v&&(r||!h):u?p&&v&&!h&&(r||!d):!h&&!d&&(r?f<=e:f<e);g?o=l+1:i=l}return Io(i,Fo)},$o=2147483647;
/** Used as references for the maximum length and index of an array. */var Bo=
/**
   * The base implementation of `_.sortedIndex` and `_.sortedLastIndex` which
   * performs a binary search of `array` to determine the index at which `value`
   * should be inserted into `array` in order to maintain its sort order.
   *
   * @private
   * @param {Array} array The sorted array to inspect.
   * @param {*} value The value to evaluate.
   * @param {boolean} [retHighest] Specify returning the highest qualified index.
   * @returns {number} Returns the index at which `value` should be inserted
   *  into `array`.
   */
function(t,e,n){var r=0,o=null==t?r:t.length;if("number"==typeof e&&e==e&&o<=$o){for(;r<o;){var i=r+o>>>1,a=t[i];null!==a&&!yn(a)&&(n?a<=e:a<e)?r=i+1:o=i}return o}return Ro(t,e,Vn,n)};
/**
   * Uses a binary search to determine the lowest index at which `value`
   * should be inserted into `array` in order to maintain its sort order.
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Array
   * @param {Array} array The sorted array to inspect.
   * @param {*} value The value to evaluate.
   * @returns {number} Returns the index at which `value` should be inserted
   *  into `array`.
   * @example
   *
   * _.sortedIndex([30, 50], 40);
   * // => 1
   */var Wo,Uo=function(t,e){return Bo(t,e)};!function(e){var n;function r(t){n=null,t&&t.off("changes",r)}function o(t,e,o){if(o)return r(),t.getTokenAt(e,o);var i=function(t,e){if(!n||!n.tokens||n.line!==e||n.cm!==t){var o=t.getLineTokens(e,!1);o.unshift(t.getTokenAt({line:e,ch:0},!1)),n={cm:t,line:e,timeStamp:Date.now(),tokens:o},t.off("changes",r),t.on("changes",r)}return n.tokens}(t,e.line);return i[Uo(i,{end:e.ch})]||t.getTokenAt(e,o)}e.getTokenAt=o,e.getInitialContext=function(t,e){return{editor:t,pos:e,token:t.getTokenAt(e,!0)}},e.movePrevToken=function(t,e){if(void 0===e&&(e=!0),t.pos.ch<=0||t.token.start<=0){if(t.pos.line<=0)return!1;t.pos.line--,t.pos.ch=t.editor.getLine(t.pos.line).length}else t.pos.ch=t.token.start;return t.token=o(t.editor,t.pos,e),!0},e.isAtStart=function(t){return(t.pos.ch<=0||t.token.start<=0)&&t.pos.line<=0},e.moveNextToken=function(t,e){var n=t.editor.getLine(t.pos.line).length;if(void 0===e&&(e=!0),t.pos.ch>=n||t.token.end>=n){if(t.pos.line>=t.editor.lineCount()-1)return!1;t.pos.line++,t.pos.ch=0}else t.pos.ch=t.token.end+1;return t.token=o(t.editor,t.pos,e),!0},e.isAtEnd=function(t){var e=t.editor.getLine(t.pos.line).length;return(t.pos.ch>=e||t.token.end>=e)&&t.pos.line>=t.editor.lineCount()-1},e.moveSkippingWhitespace=function(t,e){if(!t(e))return!1;for(;!e.token.type&&!/\S/.test(e.token.string);)if(!t(e))return!1;return!0},e.offsetInToken=function(t){var e=t.pos.ch-t.token.start;return e<0&&console.log("CodeHintUtils: _offsetInToken - Invalid context: pos not in the current token!"),e},e.getModeAt=function(e,n,r){r=r||!0;var i=e.getMode();return i.innerMode&&(i=t.innerMode(i,o(e,n,r).state).mode),{mode:i,name:"xml"===i.name?i.configuration:i.name}}}(Wo||(Wo={}));var Do=function(){function e(t){this._codeMirror=t}return e.prototype.focus=function(){this._codeMirror.focus()},e.prototype.getModeForRange=function(t,e,n){var r=this._codeMirror.getMode(),o=Wo.getModeAt(this._codeMirror,t),i=Wo.getModeAt(this._codeMirror,e);return n||r.name!==o.name?o&&i&&o.name===i.name?o:null:this._codeMirror.getOption("mode")},e.prototype.setCursorPos=function(e,n){this._codeMirror.setCursor(t.Pos(e,n))},e.prototype.indexFromPos=function(t){return this._codeMirror.indexFromPos(t)},e.prototype.setSelection=function(t,e){this.setSelections([{start:t,end:e||t}])},e.prototype.setSelections=function(t){var e=t.length-1;this._codeMirror.setSelections(t.map(function(t,n){return t.primary&&(e=n),{anchor:t.reversed?t.end:t.start,head:t.reversed?t.start:t.end}}),e,void 0)},e.prototype.convertToLineSelections=function(t,e){var n=this;zo(e=e||{},{expandEndAtStartOfLine:!1,mergeAdjacent:!0});var r,o=[];return _o(t,function(t){var i=yo(t);i.start.ch=0;var a=i.start.line!==i.end.line||i.start.ch!==i.end.ch;!e.expandEndAtStartOfLine&&a&&0===i.end.ch||(i.end={line:i.end.line+1,ch:0}),r&&n.posWithinRange(i.start,r.selectionForEdit.start,r.selectionForEdit.end,e.mergeAdjacent)?(r.selectionForEdit.end.line=i.end.line,r.selectionsToTrack.push(t)):(r={selectionForEdit:i,selectionsToTrack:[t]},o.push(r))}),o},e.prototype.getSelectedText=function(t){if(t)return this._codeMirror.getSelection();var e=this.getSelection();return this._codeMirror.getRange(e.start,e.end)},e.prototype._copyPos=function(e){return new t.Pos(e.line,e.ch)},e.prototype.posWithinRange=function(t,e,n,r){return e.line<=t.line&&n.line>=t.line&&(r?(e.line<t.line||e.ch<=t.ch)&&(n.line>t.line||n.ch>=t.ch):(e.line<t.line||e.ch<=t.ch)&&(n.line>t.line||n.ch>t.ch))},e.prototype.hasSelection=function(){return this._codeMirror.somethingSelected()},e.prototype._normalizeRange=function(t,e){return e.line<t.line||e.line===t.line&&e.ch<t.ch?{start:this._copyPos(e),end:this._copyPos(t),reversed:!0}:{start:this._copyPos(t),end:this._copyPos(e),reversed:!1}},e.prototype.getSelection=function(){return this._normalizeRange(this.getCursorPos(!1,"anchor"),this.getCursorPos(!1,"head"))},e.prototype.getSelections=function(){var t=this.getSelection(),e=this;return Yn(this._codeMirror.listSelections(),function(n){var r=e._normalizeRange(n.anchor,n.head);return r.start.line===t.start.line&&r.start.ch===t.start.ch&&r.end.line===t.end.line&&r.end.ch===t.end.ch?r.primary=!0:r.primary=!1,r})},e.prototype.getCursorPos=function(t,e){"start"===e?e="from":"end"===e&&(e="to");var n=this._copyPos(this._codeMirror.getCursor(e));return t&&(n.ch=this.getColOffset(n)),n},e.prototype.getColOffset=function(t){var n,r=this._codeMirror.getRange({line:t.line,ch:0},t),o=null,i=0;for(n=0;n<r.length;n++)"\t"===r[n]?(null===o&&(o=e.getTabSize()),o>0&&(i+=o-i%o)):i++;return i},e.getTabSize=function(){return 4},e.prototype.getText=function(){return this._codeMirror.getValue()},e.prototype.setText=function(t){this._codeMirror.setValue(t)},e}(),No=9007199254740991,Vo=Math.floor;
/** Used as references for various `Number` constants. */var qo=
/**
   * The base implementation of `_.repeat` which doesn't coerce arguments.
   *
   * @private
   * @param {string} string The string to repeat.
   * @param {number} n The number of times to repeat the string.
   * @returns {string} Returns the repeated string.
   */
function(t,e){var n="";if(!t||e<1||e>No)return n;// Leverage the exponentiation by squaring algorithm for a faster repeat.
// See https://en.wikipedia.org/wiki/Exponentiation_by_squaring for more details.
do{e%2&&(n+=t),(e=Vo(e/2))&&(t+=t)}while(e);return n},Go=NaN,Ho=/^\s+|\s+$/g,Jo=/^[-+]0x[0-9a-f]+$/i,Ko=/^0b[01]+$/i,Qo=/^0o[0-7]+$/i,Xo=parseInt;
/** Used as references for various `Number` constants. */var Yo=
/**
   * Converts `value` to a number.
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to process.
   * @returns {number} Returns the number.
   * @example
   *
   * _.toNumber(3.2);
   * // => 3.2
   *
   * _.toNumber(Number.MIN_VALUE);
   * // => 5e-324
   *
   * _.toNumber(Infinity);
   * // => Infinity
   *
   * _.toNumber('3.2');
   * // => 3.2
   */
function(t){if("number"==typeof t)return t;if(yn(t))return Go;if(z(t)){var e="function"==typeof t.valueOf?t.valueOf():t;t=z(e)?e+"":e}if("string"!=typeof t)return 0===t?t:+t;t=t.replace(Ho,"");var n=Ko.test(t);return n||Qo.test(t)?Xo(t.slice(2),n?2:8):Jo.test(t)?Go:+t},Zo=1/0,ti=17976931348623157e292;
/** Used as references for various `Number` constants. */var ei=
/**
   * Converts `value` to a finite number.
   *
   * @static
   * @memberOf _
   * @since 4.12.0
   * @category Lang
   * @param {*} value The value to convert.
   * @returns {number} Returns the converted number.
   * @example
   *
   * _.toFinite(3.2);
   * // => 3.2
   *
   * _.toFinite(Number.MIN_VALUE);
   * // => 5e-324
   *
   * _.toFinite(Infinity);
   * // => 1.7976931348623157e+308
   *
   * _.toFinite('3.2');
   * // => 3.2
   */
function(t){return t?(t=Yo(t))===Zo||t===-Zo?(t<0?-1:1)*ti:t==t?t:0:0===t?t:0};
/**
   * Converts `value` to an integer.
   *
   * **Note:** This method is loosely based on
   * [`ToInteger`](http://www.ecma-international.org/ecma-262/7.0/#sec-tointeger).
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to convert.
   * @returns {number} Returns the converted integer.
   * @example
   *
   * _.toInteger(3.2);
   * // => 3
   *
   * _.toInteger(Number.MIN_VALUE);
   * // => 0
   *
   * _.toInteger(Infinity);
   * // => 1.7976931348623157e+308
   *
   * _.toInteger('3.2');
   * // => 3
   */var ni=function(t){var e=ei(t),n=e%1;return e==e?n?e-n:e:0};
/**
   * Repeats the given string `n` times.
   *
   * @static
   * @memberOf _
   * @since 3.0.0
   * @category String
   * @param {string} [string=''] The string to repeat.
   * @param {number} [n=1] The number of times to repeat the string.
   * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
   * @returns {string} Returns the repeated string.
   * @example
   *
   * _.repeat('*', 3);
   * // => '***'
   *
   * _.repeat('abc', 2);
   * // => 'abcabc'
   *
   * _.repeat('abc', 0);
   * // => ''
   */var ri=function(t,e,n){return e=(n?Eo(t,e,n):void 0===e)?1:ni(e),qo(Cn(t),e)},oi=/[\\^$.*+?()[\]{}|]/g,ii=RegExp(oi.source);
/**
   * Used to match `RegExp`
   * [syntax characters](http://ecma-international.org/ecma-262/7.0/#sec-patterns).
   */var ai=
/**
   * Escapes the `RegExp` special characters "^", "$", "\", ".", "*", "+",
   * "?", "(", ")", "[", "]", "{", "}", and "|" in `string`.
   *
   * @static
   * @memberOf _
   * @since 3.0.0
   * @category String
   * @param {string} [string=''] The string to escape.
   * @returns {string} Returns the escaped string.
   * @example
   *
   * _.escapeRegExp('[lodash](https://lodash.com/)');
   * // => '\[lodash\]\(https://lodash\.com/\)'
   */
function(t){return(t=Cn(t))&&ii.test(t)?t.replace(oi,"\\$&"):t},ci=j?j.isConcatSpreadable:void 0;
/** Built-in value references. */var ui=
/**
   * Checks if `value` is a flattenable `arguments` object or array.
   *
   * @private
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is flattenable, else `false`.
   */
function(t){return ne(t)||ge(t)||!!(ci&&t&&t[ci])};
/**
   * The base implementation of `_.flatten` with support for restricting flattening.
   *
   * @private
   * @param {Array} array The array to flatten.
   * @param {number} depth The maximum recursion depth.
   * @param {boolean} [predicate=isFlattenable] The function invoked per iteration.
   * @param {boolean} [isStrict] Restrict to values that pass `predicate` checks.
   * @param {Array} [result=[]] The initial result value.
   * @returns {Array} Returns the new flattened array.
   */var si=function t(e,n,r,o,i){var a=-1,c=e.length;for(r||(r=ui),i||(i=[]);++a<c;){var u=e[a];n>0&&r(u)?n>1?
// Recursively flatten arrays (susceptible to call stack limits).
t(u,n-1,r,o,i):ee(i,u):o||(i[i.length]=u)}return i};
/**
   * Flattens `array` a single level deep.
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Array
   * @param {Array} array The array to flatten.
   * @returns {Array} Returns the new flattened array.
   * @example
   *
   * _.flatten([1, [2, [3, [4]], 5]]);
   * // => [1, 2, [3, [4]], 5]
   */var li,fi=function(t){return null!=t&&t.length?si(t,1):[]};!function(e){function n(e,n,r,o){var i={text:n,from:r,to:o};if(t.cmpPos(e,r)<0)return e;if(t.cmpPos(e,o)<=0)return t.changeEnd(i);var a=e.line+i.text.length-(i.to.line-i.from.line)-1,c=e.ch;return e.line===i.to.line&&(c+=t.changeEnd(i).ch-i.to.ch),{line:a,ch:c}}function r(t,e){Array.isArray(t)?_o(t,e):e(t,0)}e.doMultipleEdits=function(e,o,i){o.sort(function(e,n){var r=Array.isArray(e.edit)?e.edit[0]:e.edit,o=Array.isArray(n.edit)?n.edit[0]:n.edit;return r?o?t.cmpPos(o.start,r.start):1:-1});var a=yo(Yn(o,"selection"));return _o(o,function(e,n){r(e.edit,function(e){e&&(e.end||(e.end=e.start),n>0&&r(o[n-1].edit,function(n){if(t.cmpPos(e.end,n.start)>0)throw new Error("doMultipleEdits(): Overlapping edits specified")}))})}),e._codeMirror.operation(function(){_o(o,function(t,o){r(t.edit,function(t){if(t){e._codeMirror.replaceRange(t.text,t.start,t.end,i);var c=t.text.split("\n");_o(a,function(e,i){e&&r(e,function(e){(e.isBeforeEdit||i!==o)&&(e.start=n(e.start,c,t.start,t.end),e.end=n(e.end,c,t.start,t.end))})})}})})}),a=a.filter(function(t){return void 0!==t}),a=(a=fi(a)).sort(function(e,n){return t.cmpPos(e.start,n.start)}),_o(a,function(t){delete t.isBeforeEdit}),a}}(li||(li={}));var vi=/[^\s\u00a0]/;function hi(t,e){var n=t.getMode();return!1!==n.useInnerComments&&n.innerMode?t.getModeAt(e):n}function pi(t,e){for(var n,r,o=[],i="",a=t.length;a<e.length;a++)n=e.charAt(a),r=ai(n),o.push(i+"[^"+r+"]"),i&&o.push(i+"$"),i+=r;return new RegExp("^\\s*"+ai(t)+"($|"+o.join("|")+")")}function di(t,e,n){var r,o,i=[];return t.forEach(function(t){r=ai(t),o=!0,e&&0===e.indexOf(t)&&(i.push(pi(t,e)),o=!1),n&&e!==n&&0===n.indexOf(t)&&(i.push(pi(t,n)),o=!1),o&&i.push(new RegExp("^\\s*"+r))}),i}function gi(t,e){return e.some(function(e){return t.match(e)})}function yi(t,e,n){var r=null;return e.forEach(function(e,o){t.match(e)&&(r&&r.length<n[o].length||!r)&&(r=n[o])}),r}function bi(t,e,n,r){for(var o=!1,i=e;i<=n;i++){var a=t._codeMirror.getLine(i);if(a.match(/\S/)&&!gi(a,r)){o=!0;break}}return o}function _i(t,e,n,r,o,i){for(var a=Wo.moveSkippingWhitespace(Wo.movePrevToken,t);a&&gi(t.token.string,i);)a=Wo.moveSkippingWhitespace(Wo.movePrevToken,t);return!(!a||"comment"!==t.token.type)&&(!t.token.string.match(r)&&!t.token.string.match(o)||(e===n&&t.token.string.length===e.length?!_i(t,e,n,r,o,i):t.token.string.match(r)))}function mi(t){return null==t?0:t.search(vi)}function ji(e,n,r,o,i,a,c,u){var s,l=Wo.getInitialContext(e._codeMirror,{line:i.start.line,ch:i.start.ch}),f=e.indexFromPos(i.end),v=di(o,n,r),h=new RegExp("^"+ai(n),"g"),p=new RegExp(ai(r)+"$","g"),d=null,g=null,y=!0,b=!1,_=!1,m=!1,j=!1,k=!0,w=[],x=u.indent;function O(){return x&&"line"===c}for(a||(a=[yo(i)]),l.token.type||/\S/.test(l.token.string)||(k=Wo.moveSkippingWhitespace(Wo.moveNextToken,l));k&&"comment"!==l.token.type;)k=Wo.moveSkippingWhitespace(Wo.moveNextToken,l)&&e.indexFromPos(l.pos)<=f,y=!1;if(k&&"comment"===l.token.type){if(gi(l.token.string,v))if(0===l.token.start&&!l.token.string.match(/^\\s*/)&&y)b=_i(Wo.getInitialContext(e._codeMirror,{line:l.pos.line,ch:l.token.start}),n,r,h,p,v);else b=!1;else if(b=!0,l.token.string===n&&n===r)_i(Wo.getInitialContext(e._codeMirror,{line:l.pos.line,ch:l.token.start}),n,r,h,p,v)?Wo.moveSkippingWhitespace(Wo.movePrevToken,l):Wo.moveSkippingWhitespace(Wo.moveNextToken,l);if(b){var A=yo(l.pos);for(k=!0;k&&!l.token.string.match(h);)k=Wo.moveSkippingWhitespace(Wo.movePrevToken,l);for(d=k&&{line:l.pos.line,ch:l.token.start},l.token.string===n&&n===r&&(l=Wo.getInitialContext(e._codeMirror,yo(A)));k&&!l.token.string.match(p);)k=Wo.moveSkippingWhitespace(Wo.moveNextToken,l);g=k&&{line:l.pos.line,ch:l.token.end-r.length};do{k=Wo.moveSkippingWhitespace(Wo.moveNextToken,l)&&e.indexFromPos(l.pos)<=f}while(k&&!l.token.string.match(h));m=k&&!!l.token.string.match(h);var M=g&&{line:g.line,ch:g.ch+r.length};(M&&t.cmpPos(i.start,M)>0||d&&t.cmpPos(i.end,d)<0)&&(_=!0)}else{var S=i.end.line;0===i.end.ch&&e.hasSelection()&&S--,bi(e,i.start.line,S,v)?_=!0:j=!0}}else _=!0;if(m)s={edit:[],selection:a};else if(j)s=null;else{var P=u.padding?u.padding:"";if(_){var E=0===i.start.ch&&0===i.end.ch&&i.start.line<i.end.line,T=mi(e._codeMirror.getLine(i.start.line));if(E)if(O()){var C=mi(e._codeMirror.getLine(i.end.line-1)),z=e._codeMirror.getOption("indentWithTabs")?"\t":" ";w.push({text:ri(z,C)+r+"\n",start:{line:i.end.line,ch:0}}),w.push({text:n+"\n"+ri(z,T),start:{line:i.start.line,ch:T}})}else w.push({text:r+"\n",start:i.end}),w.push({text:n+"\n",start:i.start});else w.push({text:P+r,start:i.end}),O()?w.push({text:n+P,start:{line:i.start.line,ch:T}}):w.push({text:n+P,start:i.start});_o(a,function(e){function o(e){t.cmpPos(e,i.end)>0&&(E?e.line++:e.line===i.end.line&&(e.ch+=r.length+2*P.length)),t.cmpPos(e,i.start)>=0&&(E?e.line++:e.line!==i.start.line||O()&&e.ch<T||(e.ch+=n.length+P.length))}o(e.start),o(e.end)})}else{var F=e._codeMirror.getLine(d.line),L=F.trim(),I=0===d.ch&&n.length===L.length,R=x&&n.length===L.length,$=(S="",!1),B=!1;if(g){var W=(S=e._codeMirror.getLine(g.line)).trim();$=0===g.ch&&r.length===W.length,B=x&&r.length===W.length}if(g)if(B)w.push({text:"",start:{line:g.line,ch:0},end:{line:g.line+1,ch:0}});else if(I&&$)w.push({text:"",start:g,end:{line:g.line+1,ch:0}});else{var U=P&&S.slice(g.ch-P.length,g.ch)===P?P.length:0;w.push({text:"",start:{line:g.line,ch:g.ch-U},end:{line:g.line,ch:g.ch+r.length}})}if(R)w.push({text:"",start:{line:d.line,ch:0},end:{line:d.line+1,ch:0}});else if(I&&$)w.push({text:"",start:d,end:{line:d.line+1,ch:0}});else{var D=d.ch+n.length;P&&F.slice(D,D+P.length)===P&&(D+=P.length),w.push({text:"",start:d,end:{line:d.line,ch:D}})}_o(a,function(t){t.isBeforeEdit=!0})}s={edit:w,selection:a}}return s}function ki(t,e){return t?Array.isArray(t)?t.length>0?t:e:[t]:e}function wi(e,n,r,o){var i=e.convertToLineSelections(n,{mergeAdjacent:!1}),a=[];return _o(i,function(n){var i,c=n.selectionForEdit,u=e.getModeForRange(c.start,c.end);if(u){var s=o.getMode?o.getMode(u,c.start):hi(e._codeMirror,c.start),l=ki(o.lineComment||s.lineComment,null),f=o.blockCommentStart||s.blockCommentStart,v=o.blockCommentEnd||s.blockCommentEnd;l?i=function(e,n,r,o,i,a){var c=i.selectionForEdit,u=i.selectionsToTrack,s=di(n,r,o),l=c.start.line,f=c.end.line,v=[];0===c.end.ch&&f--;var h=bi(e,l,f,s),p=null!==a.padding&&void 0!==a.padding?a.padding:" ",d=a.commentBlankLines;if(h){var g=n[0]+p,y=null;if(a.indent){for(var b=l;b<=f;b++){var _=mi(w=e._codeMirror.getLine(b));if(0!==w.length&&-1!==_){var m=w.slice(0,_);(null===y||y.length>m.length)&&(y=m)}}for(y=null===y?"":y,b=l;b<=f;b++)if(_=mi(w=e._codeMirror.getLine(b)),d||-1!==_){var j=void 0;if(-1===_)0===w.length?(j=y+g,v.push({text:j,start:{line:b,ch:0}})):w.length===y.length?(j=g,v.push({text:j,start:{line:b,ch:w.length}})):w.length>y.length?(j=g,v.push({text:j,start:{line:b,ch:y.length}})):(j=y+g,v.push({text:j,start:{line:b,ch:0}}));else{j=g;var k=y.length;w.slice(0,k)!==y&&(k=_),v.push({text:j,start:{line:b,ch:k}})}}}else for(b=l;b<=f;b++)(d||vi.test(e._codeMirror.getLine(b)))&&v.push({text:g,start:{line:b,ch:0}});_o(u,function(e){0===e.start.ch&&0!==t.cmpPos(e.start,e.end)?(e.start={line:e.start.line,ch:0},e.end={line:e.end.line,ch:e.end.line===f?e.end.ch+g.length:0}):e.isBeforeEdit=!0})}else{for(b=l;b<=f;b++){var w,x=yi(w=e._codeMirror.getLine(b),s,n);if(x){var O=w.indexOf(x),A=O+x.length;w.slice(A,A+p.length)===p&&(A+=p.length),v.push({text:"",start:{line:b,ch:O},end:{line:b,ch:A}})}}_o(u,function(t){t.isBeforeEdit=!0})}return{edit:v,selection:u}}(e,l,f,v,n,o):(f||v)&&(i=function(t,e,n,r,o,i){var a=r.selectionForEdit;return a.end.line===a.start.line+1&&0===a.end.ch&&(a.end={line:a.start.line,ch:t._codeMirror.getLine(a.start.line).length}),ji(t,e,n,[],a,r.selectionsToTrack,o,i)}(e,f,v,n,r,o))}i||(i={selection:n.selectionsToTrack}),a.push(i)}),a}t.defineExtension("toggleLineComment",function(t){void 0===t&&(t={}),function(t,e){t.setSelections(li.doMultipleEdits(t,wi(t,t.getSelections(),"line",e)))}(new Do(this),t)}),t.defineExtension("toggleBlockComment",function(t){void 0===t&&(t={}),function(t,e){var n=[],r=[];_o(t.getSelections(),function(o){var i=t.getModeForRange(o.start,o.end),a={edit:[],selection:[o]};if(i){var c=e.getMode?e.getMode(i,o.start):hi(t._codeMirror,o.start),u=ki(e.lineComment||c.lineComment,[]),s=e.blockCommentStart||c.blockCommentStart,l=e.blockCommentEnd||c.blockCommentEnd;(s||l)&&((a=ji(t,s,l,u,o,null,"block",e))||r.push(o))}a&&n.push(a)}),n.push.apply(n,wi(t,r,"block",e)),t.setSelections(li.doMultipleEdits(t,n))}(new Do(this),t)})});
